/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:47:34 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.games.model;

/**
 * This is a JSON template for the result of checking a revision.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RevisionCheckResponse extends com.google.api.client.json.GenericJson {

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#revisionCheckResponse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The result of the revision check. Possible values are:   - "OK" - The revision being used is
   * current.  - "DEPRECATED" - There is currently a newer version available, but the revision being
   * used still works.  - "INVALID" - The revision being used is not supported in any released
   * version.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String revisionStatus;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#revisionCheckResponse.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#revisionCheckResponse.
   * @param kind kind or {@code null} for none
   */
  public RevisionCheckResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The result of the revision check. Possible values are:   - "OK" - The revision being used is
   * current.  - "DEPRECATED" - There is currently a newer version available, but the revision being
   * used still works.  - "INVALID" - The revision being used is not supported in any released
   * version.
   * @return value or {@code null} for none
   */
  public java.lang.String getRevisionStatus() {
    return revisionStatus;
  }

  /**
   * The result of the revision check. Possible values are:   - "OK" - The revision being used is
   * current.  - "DEPRECATED" - There is currently a newer version available, but the revision being
   * used still works.  - "INVALID" - The revision being used is not supported in any released
   * version.
   * @param revisionStatus revisionStatus or {@code null} for none
   */
  public RevisionCheckResponse setRevisionStatus(java.lang.String revisionStatus) {
    this.revisionStatus = revisionStatus;
    return this;
  }

  @Override
  public RevisionCheckResponse set(String fieldName, Object value) {
    return (RevisionCheckResponse) super.set(fieldName, value);
  }

  @Override
  public RevisionCheckResponse clone() {
    return (RevisionCheckResponse) super.clone();
  }

}
